package com.bcxin.rbac.domain.dtos;

import com.bcxin.Infrastructures.entities.OperatorValueType;
import lombok.Getter;

import java.util.ArrayList;
import java.util.Collection;

@Getter
public class ResourceDto {
    private final String id;
    private final String categoryId;
    private final String name;
    private final String data;
    private final String dataType;
    private final String metaId;
    private final String metaConfig;
    private final String metaData;
    private final OperatorValueType creator;
    private final OperatorValueType lastModifier;
    private final Collection<ResourceDto> children = new ArrayList<>();

    public ResourceDto(String id, String categoryId, String name, String data,
                       String dataType, String metaId, String metaConfig, String metaData,
                       OperatorValueType creator, OperatorValueType lastModifier) {
        this.id = id;
        this.categoryId = categoryId;
        this.name = name;
        this.data = data;
        this.dataType = dataType;
        this.metaId = metaId;
        this.metaConfig = metaConfig;
        this.metaData = metaData;
        this.creator = creator;
        this.lastModifier = lastModifier;
    }

    public static ResourceDto create(String id, String categoryId, String name, String data,
                                     String dataType, String metaId, String metaConfig, String metaData,
                                     OperatorValueType creator, OperatorValueType lastModifier) {
        return new ResourceDto(id, categoryId, name, data, dataType, metaId, metaConfig, metaData, creator, lastModifier);
    }

    public void addChildResource(ResourceDto resourceDto) {
        this.getChildren().add(resourceDto);
    }
}
